{McMail-Six-Line-Viewer by ThM,
 views six lines on one screen,
 public-domain, quick and dirty,
 TP-source included, have fun !}

USES DOS,Crt;

var datei:FILE; 
    fname:STRING; 
    n,i:BYTE; 

  FUNCTION VGAVorhanden: BOOLEAN; 
  var Reg : DOS.Registers; 
  BEGIN
    Reg.AX := $1A00;                     {Infobyte holen}
    Intr($10,Reg);                       {VGA mit VGA-Monitor?}
    VGAVorhanden := (Reg.AL = $1A) AND ((Reg.BL = 7) OR (Reg.BL = 8)); 
  END; 
  PROCEDURE VGAAus; 
  BEGIN
    INLINE($FA);                         {CLI: Interrputs sperren}
    Port[$3C4] := 0;                     {Sequenzer ausschalten}
    Port[$3C5] := 1; 
    Port[$3D4] := 23;                    {CRTC-Reset setzen}
    Port[$3D5] := Port[$3D5] AND 127; 
    Port[$3D4] := 17;                    {CRTC-Register 0-7 freigeben}
    Port[$3D5] := Port[$3D5] AND 127; 
  END; 
  PROCEDURE VGAEin; 
  BEGIN
    Port[$3D4] := 17;                    {CRTC-Register 0-7 sperren}
    Port[$3D5] := Port[$3D5] OR 128; 
    Port[$3D4] := 23;                    {CRTC-Reset freigeben}
    Port[$3D5] := Port[$3D5] OR 128; 
    Port[$3C4] := 0;                     {Sequenzer einschalten}
    Port[$3C5] := 3; 
    INLINE($FB);                         {STI: Interruprs erlauben}
  END; 
  PROCEDURE VGA94Spalten; 
  var Dummy: BYTE; 
  BEGIN
    Port[$3C2] := (Port[$3CC] AND $F3) OR 4;   {720 PEL whlen}
    Port[$3C4] := 1;                     {8-Dot-Mode anschalten}
    Port[$3C5] := Port[$3C5] OR 1; 
    Port[$3D4] := 0;                     {Horizontal Total-5}
    Port[$3D5] := 108; 
    Port[$3D4] := 1;                     {Hor. Display Enable End - 1}
    Port[$3D5] := 93; 
    Port[$3D4] := 2;                     {Start Horizontal Blanking}
    Port[$3D5] := 94; 
    Port[$3D4] := 3;                     {End Horizontal Blanking}
    Port[$3D5] := 128 + 15; 
    Port[$3D4] := 4;                     {Start Horizontal Retrace}
    Port[$3D5] := 98; 
    Port[$3D4] := 5;                     {End Horizontal Retrace}
    Port[$3D5] := 128 + 14; 
    Port[$3D4] := 19;                    {Logical Line Width}
    Port[$3D5] := 94 DIV 2; 
    Dummy := Port[$3DA];                 {Horizontal PEL Panning}
    Port[$3C0] := 19; 
    Port[$3C0] := 0; 
    Port[$3C0] := 32;                    {Attribute Controller}
    Port[$3C0] := 32;                    {reaktivieren}
  END; 
  PROCEDURE VGA480Rasterzeilen; 
  BEGIN
    Port[$3C2] := Port[$3CC] OR 192;     {Sync-Polaritt setzen}
    Port[$3D4] := 6;                     {Vertical Total}
    Port[$3D5] := 11;      Port[$3D4] := 7;    {CRT Overflow}
    Port[$3D5] := 62;      Port[$3D4] := 9;    {Maximum Scan Line}
    Port[$3D5] := 79;      Port[$3D4] := 16;   {Start Vertical Retrace}
    Port[$3D5] := 234;     Port[$3D4] := 17;   {End Vertical Retrace}
    Port[$3D5] := 140;     Port[$3D4] := 18;   {Vert. Display Enable End}
    Port[$3D5] := 223;     Port[$3D4] := 21;   {Start Vertical Blanking}
    Port[$3D5] := 231;     Port[$3D4] := 22;   {End Vertical Blanking}
    Port[$3D5] := 4; 
  END; 
  PROCEDURE VGAZeichenhoehe(Size : BYTE); 
  BEGIN
    Mem[0:$485] := Size;                 {BIOS informieren}
    Port[$3D4] := 9;                     {Maximum Scan Line}
    Port[$3D5] := (Port[$3D5] AND $E0) + Size - 1; 
    Port[$3D4] := 10;                    {Cursor Start}
    IF Size <= 12 THEN Port[$3D5] := Size - 2 ELSE Port[$3D5] := Size - 3; 
    Port[$3D4] := 11;                    {Cursor End}
    IF Size <= 12 THEN Port[$3D5] := Size - 1 ELSE Port[$3D5] := Size - 2; 
  END; 
  PROCEDURE VGAModus(Zeilen,Spalten : LONGINT); 
  var Reg : DOS.Registers; 
  BEGIN
    {350 oder 400 Zeilen whlen, bei 480 Zeilen vorerst nur 400}
    with Reg DO
      BEGIN
        AH := $12; 
        BL := $30; 
        IF Zeilen = 43 THEN AL := 1 ELSE AL := 2; 
      END; 
    Intr($10,Reg);                       {40 oder 80 Spalten whlen, bei 94 Spalten vorerst nur 80}
    with Reg DO
      BEGIN
        AH := 0; 
        IF Spalten = 40 THEN AL := 1 ELSE AL := 3; 
      END; 
    Intr($10,Reg);                       {Passenden Zeichensatz in Video-RAM kopieren}
    with Reg DO
      BEGIN
        AH := $11; 
        BL := 0; 
        CASE Zeilen OF
          25,30 : AL := 4;                 {16x8 Pixel}
          34    : AL := 1;                 {14x8 Pixel}
          ELSE AL := 2;                    {8x8 Pixel}
        END; 
      END; 
    Intr($10,Reg); 
    VGAAus;     {Jetzt geht's an die Register}
    IF Spalten = 94 THEN VGA94Spalten;   {Ggf. 94 Spalten auswhlen}
    IF Zeilen IN [30,34,60]
    THEN VGA480Rasterzeilen;             {Ggf. 480 Zeilen}
    CASE Zeilen OF                       {Die VGA ber die Zeichenhhe informieren}
      25,30 : VGAZeichenhoehe(16); 
      34    : VGAZeichenhoehe(14); 
      ELSE VGAZeichenhoehe(8); 
    END; 
    VGAEin;                              {Alles wieder normal}
    Mem[0:$44A] := Spalten;              {BIOS ber die Bildschirmgre informieren}
    Mem[0:$484] := Zeilen - 1; 
  END; 


BEGIN
  IF NOT(VGAVorhanden) THEN BEGIN
    WriteLn('Go out and buy yourself a graphics card ... ;-)'); 
    Halt(1); 
  END;
  IF (GetEnv('MCMAIL')='') THEN BEGIN
    WriteLn('Show me where you have your mailer, set "MCMAIL" in enviroment !');
    Halt(2);
  END;
  vgamodus(60,80);
  REPEAT
    FOR n:=0 TO 5 DO BEGIN
      Str(n+1,FName);
      FName:=GetEnv('MCMAIL')+'\mcmail'+FName+'.scr';
      Assign(Datei,FName);
      filemode:=0;
      Reset(datei,2);
      IF IOResult=0 THEN BEGIN
        FOR i:=0 to 10 DO BEGIN
          BlockRead(datei,mem[$b800:1600*n+i*160],78);
        END;
        Close(datei); 
      END;
    END; 
    i:=0; 
    REPEAT
      Delay(100); 
      inc(i); 
    until (i=100) OR (KeyPressed); 
  UNTIL (KeyPressed) AND (ReadKey<>#0); 
  TextMode(co80); 
END.