;=============================================================================
; Costtable for McMail  Meiningen
;=============================================================================
;
; In the first section you can define a part of phonenumbers to different
; Cost-Zones
;
; <number> <CostZone-Keyword>
;
; The max length of the CostZone-Keyword is 20 chars.
;=============================================================================

; Inland default (21/42 Sekunden)

  49-     National


; Nahbereich = 720 Sekunden

  49-3693  NahZone       ;Meiningen
  49-36843 NahZone       ;Benshausen
  49-36943 NahZone       ;Bettenhausen
  49-36846 NahZone       ;Dietzhausen
  49-36945 NahZone       ;Henneberg
  49-36947 NahZone       ;Jchsen
  49-36966 NahZone       ;Kaltennordheim
  49-9776  NahZone       ;Mellrichstadt
  49-9779  NahZone       ;Nordheim
  49-36949 NahZone       ;Obermafeld
  49-36940 NahZone       ;Oepfershausen
  49-9777  NahZone       ;Ostheim
  49-36944 NahZone       ;Rentwertshausen
  49-36844 NahZone       ;Rohr
  49-3683  NahZone       ;Schmalkalden
  49-36847 NahZone       ;Steinbach-Hallenberg
  49-3681  NahZone       ;Suhl
  49-36873 NahZone       ;Themar
  49-36941 NahZone       ;Wasungen
  49-36848 NahZone       ;Wernshausen

; Regional Zone bis 50 km (120 Sekunden)

  49-36205 Regional
  49-36207 Regional
  49-3621  Regional
  49-3622  Regional
  49-3623  Regional
  49-3624  Regional
  49-36252 Regional
  49-36253 Regional
  49-36254 Regional
  49-36256 Regional
  49-36257 Regional
  49-36259 Regional
  49-3628  Regional
  49-36704 Regional
  49-36738 Regional
  49-36766 Regional
  49-3677  Regional
  49-36781 Regional
  49-36782 Regional
  49-36783 Regional
  49-36784 Regional
  49-36785 Regional
  49-3682  Regional
  49-36840 Regional
  49-36841 Regional
  49-36842 Regional
  49-36845 Regional
  49-36849 Regional
  49-3685  Regional
  49-3686  Regional
  49-36870 Regional
  49-36871 Regional
  49-36874 Regional
  49-36875 Regional
  49-36878 Regional
  49-3691  Regional
  49-36920 Regional
  49-36921 Regional
  49-36925 Regional
  49-36927 Regional
  49-36928 Regional
  49-36929 Regional
  49-36946 Regional
  49-36948 Regional
  49-3695  Regional
  49-36961 Regional
  49-36962 Regional
  49-36963 Regional
  49-36964 Regional
  49-36965 Regional
  49-36967 Regional
  49-36968 Regional
  49-36969 Regional
  49-6620  Regional
  49-6624  Regional
  49-6629  Regional
  49-6651  Regional
  49-6652  Regional
  49-6654  Regional
  49-6656  Regional
  49-6657  Regional
  49-6658  Regional
  49-6672  Regional
  49-6676  Regional
  49-6681  Regional
  49-6682  Regional
  49-6683  Regional
  49-6684  Regional
  49-9523  Regional
  49-9532  Regional
  49-9564  Regional
  49-9566  Regional
  49-9567  Regional
  49-9700  Regional
  49-9701  Regional
  49-9708  Regional
  49-971   Regional
  49-9724  Regional
  49-9733  Regional
  49-9734  Regional
  49-9735  Regional
  49-9738  Regional
  49-9745  Regional
  49-9747  Regional
  49-9749  Regional
  49-9761  Regional
  49-9762  Regional
  49-9763  Regional
  49-9764  Regional
  49-9765  Regional
  49-9766  Regional
  49-9771  Regional
  49-9772  Regional
  49-9773  Regional
  49-9774  Regional
  49-9775  Regional
  49-9778  Regional


; Ausland 1 (16 Sekunden)

  33-     Europa_1       ; Andorra
  32-     Europa_1       ; Belgien
  45-     Europa_1       ; Dnemark
  298-    Europa_1       ; Farer
  33-     Europa_1       ; Frankreich
  30-     Europa_1       ; Griechenland  (ab 2000 Uhr)
  44-     Europa_1       ; Grobritannien & Nordirland
  353-    Europa_1       ; Irland
  39-     Europa_1       ; Italien (ab 2000 Uhr)
                         ; Lichtenstein
  352-    Europa_1       ; Luxemburg
                         ; Monaco
  31-     Europa_1       ; Niederlande
  43-     Europa_1       ; sterreich
  351-    Europa_1       ; Portugal (ab 2000 Uhr)
                         ; San Marino (ab 2000 Uhr)
  41-     Europa_1       ; Schweiz
  34-     Europa_1       ; Spanien (ab 2000 Uhr)
  42-     Europa_1       ; Tschechoslowakai
                         ; Vatikanstadt (ab 2000 Uhr)

; Ausland 2 (10,6 Sekunden)

  20-     Europa_2       ; gypten
  213-    Europa_2       ; Algerien
  359-    Europa_2       ; Bulgarien
  358-    Europa_2       ; Finnland
  350-    Europa_2       ; Gibraltar
  354-    Europa_2       ; Island
  972-    Europa_2       ; Israel
  962-    Europa_2       ; Jordanien
  38-     Europa_2       ; Jugoslawien
  218-    Europa_2       ; Libyen
  356-    Europa_2       ; Malta
  212-    Europa_2       ; Marokko
  47-     Europa_2       ; Norwegen
  48-     Europa_2       ; Polen
  40-     Europa_2       ; Rumnien
  46-     Europa_2       ; Schweden
  963-    Europa_2       ; Syrien
  90-     Europa_2       ; Trkei
  216-    Europa_2       ; Tunesien
  7-      Europa_2       ; UdSSR
  36-     Europa_2       ; Ungarn
  357-    Europa_2       ; Zypern

;=============================================================================
;
; In the second section you can define different costunits and timeunits to
; the CostZone-Keyword you have defined in the first section.
;
;                                    Matching tag in the timebar
;                                    | CostUnit per TimeUnit for Tag B
; CostZone-Keyword                   | |  TimeUnit in sec for Tag B
: |                                  | |  |  Matching tag in the timebar
; |    Weekday this define is active | |  |  | CostUnit per TimeUnit for Tag N
; |       |                          | |  |  | |  TimeUnit in sec for Tag N
; |       |  {-- The timebar--------}| |  |  | |  |
; T-Zone1 Mon BBBBBBBB...NBBBBBBBBBB B,23,42 N,23,21
;
; You can use 'All' as weekday for all days. Any 'Default' define has to
; stay before all other defines!
;
; This example is valid for Oldenburg, Germany.
; B - Billigtarif, N - Normaltarif
;
; You can define as much tags as you want in the timebar, but for each
; different tag you have to define a valid CostUnit/TimeUnit entry
;
; The list will be processed topdown, that means, if you have 2 defines with
; the same CostZone-Keywords and the same day, the second will be used.
;
; Example:
;
;  On all days except Saturday and Sunday the first entry will be used.
;
;  Regional All BBBBBBBBBBBBBBBBNNNN...
;  Regional Sat BBBBBBBBBBBBBBBBBBBB...
;  Regional Sun BBBBBBBBBBBBBBBBBBBB...
;
;=============================================================================

;DayTime in  0                   1                   2
;30min step  0.1.2.3.4.5.6.7.8.9.0.1.2.3.4.5.6.7.8.9.0.1.2.3.

Default  All BBBBBBBBBBBBBBBBNNNNNNNNNNNNNNNNNNNNBBBBBBBBBBBB B,23,4 N,23,2
Default  Sat BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB B,23,4
Default  Sun BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB B,23,4

NahZone  All BBBBBBBBBBBBBBBBNNNNNNNNNNNNNNNNNNNNBBBBBBBBBBBB B,23,720 N,23,360
NahZone  Sat BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB B,23,720
NahZone  Sun BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB B,23,720

Regional All BBBBBBBBBBBBBBBBNNNNNNNNNNNNNNNNNNNNBBBBBBBBBBBB B,23,120 N,23,60
Regional Sat BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB B,23,120
Regional Sun BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB B,23,120

National All BBBBBBBBBBBBBBBBNNNNNNNNNNNNNNNNNNNNBBBBBBBBBBBB B,23,42 N,23,21
National Sat BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB B,23,42
National Sun BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB B,23,42

Europa_1 All BBBBBBBBBBBBBBBBNNNNNNNNNNNNNNNNNNNNBBBBBBBBBBBB B,23,16 N,23,8
Europa_1 Sat BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB B,23,16
Europa_1 Sun BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB B,23,16

Europa_2 Mon BBBBBBBBBBBBBBBBNNNNNNNNNNNNNNNNNNNNBBBBBBBBBBBB B,23,10 N,23,5
Europa_2 Tue BBBBBBBBBBBBBBBBNNNNNNNNNNNNNNNNNNNNBBBBBBBBBBBB B,23,10 N,23,5
Europa_2 Wed BBBBBBBBBBBBBBBBNNNNNNNNNNNNNNNNNNNNBBBBBBBBBBBB B,23,10 N,23,5
Europa_2 Thu BBBBBBBBBBBBBBBBNNNNNNNNNNNNNNNNNNNNBBBBBBBBBBBB B,23,10 N,23,5
Europa_2 Fri BBBBBBBBBBBBBBBBNNNNNNNNNNNNNNNNNNNNBBBBBBBBBBBB B,23,10 N,23,5
Europa_2 Sat BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB B,23,10
Europa_2 Sun BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB B,23,10

;=============================================================================
;EOF
;=============================================================================